MOUNT_UMAPFS(8)

NAME
mount_umapfs - sample file system layer

SYNOPSIS
mount_umapfs [-o options] -u uid-mapfile -g gid-mapfile target mount-point

DESCRIPTION
The mount_umapfs utility is used to mount a sub-tree of an existing file system that uses a different set of uids and gids than the local system. Such a file system could be mounted from a remote site via NFS or it could be a file system on removable media brought from some foreign location that uses a different password file.

The mount_umapfs utility uses a set of files provided by the user to make correspondences between uids and gids in the sub-tree's original environment and some other set of ids in the local environment. For instance, user smith might have uid 1000 in the original environment, while having uid 2000 in the local environment. The mount_umapfs utility allows the subtree from smith's original environment to be mapped in such a way that all files with owning uid 1000 look like they are actually owned by uid 2000.

The options are as follows:

-o  Options are specified with a -o flag followed by a comma separated string of options. See the mount(8) man page for possible options and their meanings.

target
    Should be the current location of the sub-tree in the local system's name space.

mount-point
    Should be a directory where the mapped subtree is to be placed.

-u uid-mapfile

-g gid-mapfile
    Describe the mappings to be made between identifiers. Briefly, the format of these files is a count of the number of mappings on the first line, with each subsequent line containing a single mapping. Each of these mappings consists of an id in the local environment and the corresponding id from the original environment, separated by white space. Uid-mapfile should contain all uid mappings, and gid-mapfile should contain all gid mappings. Any uids not mapped in uid-mapfile will be treated as user NOBODY, and any gids not mapped in gid-mapfile will be treated as group NULLGROUP. At most 64 uids can be mapped for a given subtree, and at most 16 groups can be mapped by a given subtree.

The mapfiles can be located anywhere in the file hierarchy, but they must be owned by root, and they must be writable only by root. The mount_umapfs utility will refuse to map the sub-tree if the ownership or permissions on these files are improper. It will also balk if the count of mappings in the first line of the map files is not correct.

The layer created by the mount_umapfs utility is meant to serve as a simple example of file system layering. It is not meant for production use. The implementation is not very sophisticated.

SEE ALSO
mount(8), mount_nullfs(8)

HISTORY
The mount_umapfs utility first appeared in 4.4BSD.

BUGS
THIS FILE SYSTEM TYPE IS NOT YET FULLY SUPPORTED (READ: IT DOESN'T WORK) AND USING IT MAY, IN FACT, DESTROY DATA ON YOUR SYSTEM. USE AT YOUR OWN RISK. BEWARE OF DOG. SLIPPERY WHEN WET.

This code also needs an owner in order to be less dangerous - serious hackers can apply by sending mail to <hackers@FreeBSD.org> and announcing their intent to take it over.